package com.hai.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighTyAgentOilStationExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighTyAgentOilStationExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdIsNull() {
            addCriterion("organization_id is null");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdIsNotNull() {
            addCriterion("organization_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdEqualTo(Long value) {
            addCriterion("organization_id =", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdNotEqualTo(Long value) {
            addCriterion("organization_id <>", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdGreaterThan(Long value) {
            addCriterion("organization_id >", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdGreaterThanOrEqualTo(Long value) {
            addCriterion("organization_id >=", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdLessThan(Long value) {
            addCriterion("organization_id <", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdLessThanOrEqualTo(Long value) {
            addCriterion("organization_id <=", value, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdIn(List<Long> values) {
            addCriterion("organization_id in", values, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdNotIn(List<Long> values) {
            addCriterion("organization_id not in", values, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdBetween(Long value1, Long value2) {
            addCriterion("organization_id between", value1, value2, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationIdNotBetween(Long value1, Long value2) {
            addCriterion("organization_id not between", value1, value2, "organizationId");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameIsNull() {
            addCriterion("organization_name is null");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameIsNotNull() {
            addCriterion("organization_name is not null");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameEqualTo(String value) {
            addCriterion("organization_name =", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameNotEqualTo(String value) {
            addCriterion("organization_name <>", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameGreaterThan(String value) {
            addCriterion("organization_name >", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameGreaterThanOrEqualTo(String value) {
            addCriterion("organization_name >=", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameLessThan(String value) {
            addCriterion("organization_name <", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameLessThanOrEqualTo(String value) {
            addCriterion("organization_name <=", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameLike(String value) {
            addCriterion("organization_name like", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameNotLike(String value) {
            addCriterion("organization_name not like", value, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameIn(List<String> values) {
            addCriterion("organization_name in", values, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameNotIn(List<String> values) {
            addCriterion("organization_name not in", values, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameBetween(String value1, String value2) {
            addCriterion("organization_name between", value1, value2, "organizationName");
            return (Criteria) this;
        }

        public Criteria andOrganizationNameNotBetween(String value1, String value2) {
            addCriterion("organization_name not between", value1, value2, "organizationName");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdIsNull() {
            addCriterion("ty_agent_id is null");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdIsNotNull() {
            addCriterion("ty_agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdEqualTo(Long value) {
            addCriterion("ty_agent_id =", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdNotEqualTo(Long value) {
            addCriterion("ty_agent_id <>", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdGreaterThan(Long value) {
            addCriterion("ty_agent_id >", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("ty_agent_id >=", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdLessThan(Long value) {
            addCriterion("ty_agent_id <", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("ty_agent_id <=", value, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdIn(List<Long> values) {
            addCriterion("ty_agent_id in", values, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdNotIn(List<Long> values) {
            addCriterion("ty_agent_id not in", values, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdBetween(Long value1, Long value2) {
            addCriterion("ty_agent_id between", value1, value2, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("ty_agent_id not between", value1, value2, "tyAgentId");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameIsNull() {
            addCriterion("ty_agent_name is null");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameIsNotNull() {
            addCriterion("ty_agent_name is not null");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameEqualTo(String value) {
            addCriterion("ty_agent_name =", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameNotEqualTo(String value) {
            addCriterion("ty_agent_name <>", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameGreaterThan(String value) {
            addCriterion("ty_agent_name >", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameGreaterThanOrEqualTo(String value) {
            addCriterion("ty_agent_name >=", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameLessThan(String value) {
            addCriterion("ty_agent_name <", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameLessThanOrEqualTo(String value) {
            addCriterion("ty_agent_name <=", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameLike(String value) {
            addCriterion("ty_agent_name like", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameNotLike(String value) {
            addCriterion("ty_agent_name not like", value, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameIn(List<String> values) {
            addCriterion("ty_agent_name in", values, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameNotIn(List<String> values) {
            addCriterion("ty_agent_name not in", values, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameBetween(String value1, String value2) {
            addCriterion("ty_agent_name between", value1, value2, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTyAgentNameNotBetween(String value1, String value2) {
            addCriterion("ty_agent_name not between", value1, value2, "tyAgentName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdIsNull() {
            addCriterion("ty_salesman_id is null");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdIsNotNull() {
            addCriterion("ty_salesman_id is not null");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdEqualTo(Long value) {
            addCriterion("ty_salesman_id =", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdNotEqualTo(Long value) {
            addCriterion("ty_salesman_id <>", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdGreaterThan(Long value) {
            addCriterion("ty_salesman_id >", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdGreaterThanOrEqualTo(Long value) {
            addCriterion("ty_salesman_id >=", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdLessThan(Long value) {
            addCriterion("ty_salesman_id <", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdLessThanOrEqualTo(Long value) {
            addCriterion("ty_salesman_id <=", value, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdIn(List<Long> values) {
            addCriterion("ty_salesman_id in", values, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdNotIn(List<Long> values) {
            addCriterion("ty_salesman_id not in", values, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdBetween(Long value1, Long value2) {
            addCriterion("ty_salesman_id between", value1, value2, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanIdNotBetween(Long value1, Long value2) {
            addCriterion("ty_salesman_id not between", value1, value2, "tySalesmanId");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameIsNull() {
            addCriterion("ty_salesman_name is null");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameIsNotNull() {
            addCriterion("ty_salesman_name is not null");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameEqualTo(String value) {
            addCriterion("ty_salesman_name =", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameNotEqualTo(String value) {
            addCriterion("ty_salesman_name <>", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameGreaterThan(String value) {
            addCriterion("ty_salesman_name >", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameGreaterThanOrEqualTo(String value) {
            addCriterion("ty_salesman_name >=", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameLessThan(String value) {
            addCriterion("ty_salesman_name <", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameLessThanOrEqualTo(String value) {
            addCriterion("ty_salesman_name <=", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameLike(String value) {
            addCriterion("ty_salesman_name like", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameNotLike(String value) {
            addCriterion("ty_salesman_name not like", value, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameIn(List<String> values) {
            addCriterion("ty_salesman_name in", values, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameNotIn(List<String> values) {
            addCriterion("ty_salesman_name not in", values, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameBetween(String value1, String value2) {
            addCriterion("ty_salesman_name between", value1, value2, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andTySalesmanNameNotBetween(String value1, String value2) {
            addCriterion("ty_salesman_name not between", value1, value2, "tySalesmanName");
            return (Criteria) this;
        }

        public Criteria andOilStationIdIsNull() {
            addCriterion("oil_station_id is null");
            return (Criteria) this;
        }

        public Criteria andOilStationIdIsNotNull() {
            addCriterion("oil_station_id is not null");
            return (Criteria) this;
        }

        public Criteria andOilStationIdEqualTo(Long value) {
            addCriterion("oil_station_id =", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdNotEqualTo(Long value) {
            addCriterion("oil_station_id <>", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdGreaterThan(Long value) {
            addCriterion("oil_station_id >", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdGreaterThanOrEqualTo(Long value) {
            addCriterion("oil_station_id >=", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdLessThan(Long value) {
            addCriterion("oil_station_id <", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdLessThanOrEqualTo(Long value) {
            addCriterion("oil_station_id <=", value, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdIn(List<Long> values) {
            addCriterion("oil_station_id in", values, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdNotIn(List<Long> values) {
            addCriterion("oil_station_id not in", values, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdBetween(Long value1, Long value2) {
            addCriterion("oil_station_id between", value1, value2, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationIdNotBetween(Long value1, Long value2) {
            addCriterion("oil_station_id not between", value1, value2, "oilStationId");
            return (Criteria) this;
        }

        public Criteria andOilStationNameIsNull() {
            addCriterion("oil_station_name is null");
            return (Criteria) this;
        }

        public Criteria andOilStationNameIsNotNull() {
            addCriterion("oil_station_name is not null");
            return (Criteria) this;
        }

        public Criteria andOilStationNameEqualTo(String value) {
            addCriterion("oil_station_name =", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameNotEqualTo(String value) {
            addCriterion("oil_station_name <>", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameGreaterThan(String value) {
            addCriterion("oil_station_name >", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameGreaterThanOrEqualTo(String value) {
            addCriterion("oil_station_name >=", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameLessThan(String value) {
            addCriterion("oil_station_name <", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameLessThanOrEqualTo(String value) {
            addCriterion("oil_station_name <=", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameLike(String value) {
            addCriterion("oil_station_name like", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameNotLike(String value) {
            addCriterion("oil_station_name not like", value, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameIn(List<String> values) {
            addCriterion("oil_station_name in", values, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameNotIn(List<String> values) {
            addCriterion("oil_station_name not in", values, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameBetween(String value1, String value2) {
            addCriterion("oil_station_name between", value1, value2, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andOilStationNameNotBetween(String value1, String value2) {
            addCriterion("oil_station_name not between", value1, value2, "oilStationName");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}